      subroutine kzphynew(XPAR,NPAR)
      implicit double precision (a-h,o-z)
      COMMON / INOUT / INUT,IOUT
      common /specx/ ifleptok,inter,xmx,delta
      real*8 xmx,delta
      common /kalino/ ifkalin

      REAL*4   XPAR(40)
      INTEGER  NPAR(40)
      REAL*8            ENE ,AMIN,AMFIN,p1(4),p2(4)
      INTEGER           IDE,IDF
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8           SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      COMMON / GSWPRM /SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      COMMON / QEDPRM /ALFINV,ALFPI,XK0
      REAL*8           ALFINV,ALFPI,XK0
      common /anomopti/ EMINACT,EMAXACT,PTACT,IRECSOFT,IENRICH
      COMMON /NEWMOD/  AMNEUT,NNEUT
      REAL*8           AMNEUT

      NNEUT=3

 !leptoquars switched off now ...
      ifleptok=0     ! switch on and off ( 1/0) lepttoquarks
      inter=-1     ! inter=-2,-1,1,2
      xmx=200    ! mass of leptoquark
      delta=-.2d0  ! additional parameter (size of coupling
!
      xmx=xpar(19)
      delta=xpar(20)
      ifleptok=npar(13)
      inter=npar(14)
      ifkalin=npar(15)
!      CALL KK2f_GetBeams(    p1,p2)

      CALL BornV_GetMZ(    AMZ)
      CALL BornV_GetGammZ( GammZ)
      CALL BornV_GetSwsq(  swsq )
      AMIN   =  BornV_GetMass(   11)
      AMFIN  =  BornV_GetMass(   16)
      IDE=2
      IDF=1
      CALL KK2f_GetCMSene(Ene)
      Ene=Ene/2D0
      if (ifleptok.eq.1) then
        write(iout,*) 'leptoquarks are on !!!!'
        write(iout,*) 'interaction type:',inter
        write(iout,*) 'mass of leptoquark:',xmx
        write(iout,*) 'couplinng parameter delta=',delta
         iktor=abs(inter)
        if(iktor.lt.1.or.iktor.gt.2) then
         write (*,*) 'stop; wrong inter',inter
         stop
        endif
      elseif(ifleptok.eq.0) then
        write(iout,*) 'leptoquarks are off !!!!'
      else
        write(iout,*) 'wrong ifleptok=',ifleptok
        stop
      endif

! anomalka requires initialization
      if (ifkalin.eq.1) then
        write(iout,*) 'NNEUT=',NNEUT
        write(iout,*) 'anomalous w-w-gamma coup. are on !!!!'
        gamw=2.2
        amw =amz*sqrt(1d0-swsq)
        call anomini(swsq,amz,gammz,amw,gamw)
      elseif (ifkalin.eq.2) then
        write(iout,*) 'anomalous tau-tau-gamma coup. are on !!!!'

 ! copy koralz constants to a common used by anomini_l3
       isfl = 1                   ! Simple flag for TTG (1 = Riemann approx.)
       if2  = 1                   ! Compute weights for MDM (f_2) (1=on,0=off)
       if3  = 0                   ! Compute weights for EDM (f_3) (1=on,0=off)
       call kz_storeparms(ene,swsq,alfinv,amz,gammz,amfin,isfl,if2,if3)
       call anomini_l3
      elseif (ifkalin.eq.0) then
        write(iout,*) 'anomalous z-z-gamma coup. are off !!!'
      else
        write(iout,*) 'wrong ifkalin=',ifkalin
        stop
      endif

c 
        IENRICH=0
        IRECSOFT=0

      if(ifkalin.eq.1.or.ifkalin.eq.2) then
C if you want to change do it here
        IENRICH= 0!  1
        IRECSOFT=  1
        EMINACT=5   ! min. sum of all photon energies for anom to be calc
        EMAXACT=1000! max. sum of all photon energies for anom to be calc
        PTACT  =.2   ! min. pT (beam) of all phot sum for anom to be calc
         if (ifkalin.ne.1.and.ienrich.eq.1) then
           write(iout,*) 'ienrich set to zero, ifkalin ne 1'
           ienrich=0
         endif

        write(iout,7000) IENRICH,IRECSOFT,EMINACT,EMAXACT,PTACT
       endif
 7000 FORMAT(///1X,15(5HKKKKK)
     $ /,' K',     25X,'additional initialization of generator:',9X,1HK
     $ /,' K',     25X,'       10.12.2000                      ',9X,1HK
     $ /,' K',I20  ,5X,'hard phot. configurations enriched? y/n',9X,1HK
     $ /,' K',I20  ,5X,'soft photon configurations removed? y/n',9X,1HK
     $ /,' K',F20.9,5X,'EMINACT: min energy that anom is calc. ',9X,1HK
     $ /,' K',F20.9,5X,'EMAXACT: max energy that anom is calc. ',9X,1HK
     $ /,' K',F20.9,5X,'PTACT  : min pT that anom is calc.     ',9X,1HK
     $ /,' K',F20.9,5X,'WARNING: THIS IS LIBRARY FOR KORALZ    ',9X,1HK
     $ /,' K',F20.9,5X,'WARNING: FOR KKMC nunu mode WTKAL(i)   ',9X,1HK
     $ /,' K',F20.9,5X,'WARNING: must be divided by WTKAL(1)   ',9X,1HK
     $ /,' K',F20.9,5X,'WARNING: tau-tau-gamma never tested    ',9X,1HK
     $ /,' K',F20.9,5X,'WARNING: but it may work if lib loaded ',9X,1HK
     $ /,1X,15(5HKKKKK)/)
      
      end

!      subroutine anomini(swsq,amz,gammz,amw,gamw)
!      implicit double precision (a-h,o,z)
!      end
!      subroutine anomini_l3
!      implicit double precision (a-h,o,z)
!      end

!      FUNCTION WTANOM(Dumm)
!      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
!      wtanom=1d0
!      end

!!      FUNCTION FKALIN(mode,QF1,QF2,PH)
 !     REAL*8 QF1(4),QF2(4)
 !     REAL*8 PH(4),PB1(4),PB2(4),PHN(4)
 !     FKALIN=1D0
 !     END
!      SUBROUTINE KZ_STOREPARMS(ene,swsq,alfinv,amz,gammz,amfin,il,i2,i3)
!      double precision ene,swsq,alfinv,amz,gammz,amfin
!      end
!      function photmore(svar)
!      IMPLICIT REAL*8 (A-H,O-Z)
C
!      photmore=1d0
!      end
      FUNCTION WTANOM(Dumm)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX      
      COMMON / MOMFIN / YF1(4),YF2(4),YPHUM(4),YPHOT(100,4),NPHOY      
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      common /kalinout/ wtkal(6) 
      common /anomopti/ EMINACT,EMAXACT,PTACT,IRECSOFT,IENRICH
      REAL*8 PP(4),PM(4),PP1(4),PM1(4),QP1(4),QM1(4),P(4),Q(4)
      REAL*8 PP2(4),PM2(4),QP2(4),QM2(4)
      REAL*8 QP(4),QM(4),phtru(4),test(4)
      REAL*8 WTL3,XANO
      COMPLEX*16 CPRZ0M
      COMPLEX*16 CPRAM
      LOGICAL IFINI,BETTER
      REAL*8 PH(4),PB1(4),PB2(4),PHN(4),ps(4),qf1p(4),qf2p(4)
      common /kalino/ ifkalin
      DATA  BETTER /.FALSE./
      WTANOM=1.D0
      WTANOM1=1.D0
!!
!      IF(NPHOT.EQ.0) WTANOM=0.D0
!!
      IF(ifkalin.EQ.0) RETURN
      CALL KK2f_GetFermions( qf1,qf2)
      CALL KK2f_GetFermions( xf1,xf2)
      CALL KK2f_GetFermions( yf1,yf2)
      CALL KK2f_GetPhotAll(Nphot,sPhot)
      do k=1,4
        sphum(k)=0D0
        do l=1,nphot
          sphum(k)=sphum(k)+sPhot(l,k)
        enddo
      enddo

         svar=(qf1(4)+qf2(4))**2-(qf1(3)+qf2(3))**2
     $       -(qf1(2)+qf2(2))**2-(qf1(1)+qf2(1))**2
         wtkal(1)=1d0/photmore(svar)
      if (ifkalin.eq.1) then
        do k=2,6
           wtkal(k)=wtkal(1)
         enddo
      elseif (ifkalin.eq.2) then
        do k=3,6
           wtkal(k)=0d0
         enddo
         wtkal(2)=wtkal(1)
      endif
      IF (IRECSOFT.EQ.1) WTANOM=0.D0
      IF(NPHOT.EQ.0) RETURN
      if(sphum(4).lt.EMINACT) return
      if(sphum(4).gt.EMAXACT) return
      pthis=0d0
      do k=1,nphot   
       pthis=max(pthis,sphot(k,1)**2+sphot(k,2)**2)
      enddo
       if (pthis.lt.PTACT**2) return
C!      if(sphum(1)**2+sphum(1)**2.lt.PTACT) return
C-initialization and cleaning after previous use

      if (ifkalin.eq.1) then         
!     ######################
        BETTER=.true.
        IFINI=.true.
      elseif (ifkalin.eq.2) then
!     ##########################
        BETTER=.false.
        IFINI=.false.
      else
!     ####
        write(*,*) 'stop in wtanom, wrong IFKALIN=',IFKALIN
        stop
       endif
!     #####

C 4-MOMENTA OF BEAMS
        DO 7 K=1,4
        PP(K)=0D0
    7   PM(K)=0D0
C
        PP(4)= ENE
        PM(4)= ENE
        PP(3)= ENE
        PM(3)=-ENE
C 4-MOMENTA OF 'DRESSED' FERMIONS
        DO 9 K=1,4
        QP(K) =QF1(K)
        QM(K) =QF2(K)
        PP1(K)=PP(K)
        PM1(K)=PM(K)
        QP1(K)=QP(K)
    9   QM1(K)=QM(K)
        xmmax=-500d0
C
        DO 77 KPHOT=1,NPHOT
C       == == =============
C ADDITION OF THE PHOTON PH TO FERMION OF MINIMAL MASS OF
C FERMION PHOTON STATE
        DO 8 K=1,4
          PH (K)=SPHOT(KPHOT,K)
          PP2(K)=PP(K)-PH(K)
          PM2(K)=PM(K)-PH(K)
          QP2(K)=QP(K)+PH(K)
    8     QM2(K)=QM(K)+PH(K)
C
        CALL MULSK(PP2,PP2,XM1)
        CALL MULSK(PM2,PM2,XM2)
        CALL MULSK(QP2,QP2,XM3)
        CALL MULSK(QM2,QM2,XM4)
        XXKM=1D0-PH(4)/ENE
C possible modifications see same below
        FACINI=CDABS(CPRZ0M(1,4D00*ENE**2*XXKM))**2
C    $        +CDABS(CPRAM (1,4D00*ENE**2*XXKM))**2
        FACFIN=CDABS(CPRZ0M(1,4D00*ENE**2))**2
C    $        +CDABS(CPRAM (1,4D00*ENE**2))**2
        XM1=XM1/FACINI
        XM2=XM2/FACINI
        XM3=XM3/FACFIN
        XM4=XM4/FACFIN
        IF (IFINI) XM1=-(ph(1)**2+ph(2)**2)*(2-ph(3)/abs(ph(3)))
        IF (IFINI) XM2=-(ph(1)**2+ph(2)**2)*(2+ph(3)/abs(ph(3)))
        IF (BETTER) THEN
          IF (IFINI) THEN 
           XM=MIN(-XM1,-XM2,-XM1,-XM2)
          ELSE
           XM=MIN( XM4, XM3, XM3, XM4)
          ENDIF
        ELSE
           XM=MIN(-XM1,-XM2, XM3, XM4)
        ENDIF
        xmmax=max(xmmax,xm)
 77     continue
C
        DO 78 KPHOT=1,NPHOT
C       == == =============
C ADDITION OF THE PHOTON PH TO FERMION OF MINIMAL MASS OF
C FERMION PHOTON STATE
        DO  K=1,4
          PH (K)=SPHOT(KPHOT,K)
          PP2(K)=PP(K)-PH(K)
          PM2(K)=PM(K)-PH(K)
          QP2(K)=QP(K)+PH(K)
          QM2(K)=QM(K)+PH(K)
        enddo
C
        CALL MULSK(PP2,PP2,XM1)
        CALL MULSK(PM2,PM2,XM2)
        CALL MULSK(QP2,QP2,XM3)
        CALL MULSK(QM2,QM2,XM4)
        XXKM=1D0-PH(4)/ENE
C possible modifications see same above
        FACINI=CDABS(CPRZ0M(1,4D00*ENE**2*XXKM))**2
C    $        +CDABS(CPRAM (1,4D00*ENE**2*XXKM))**2
        FACFIN=CDABS(CPRZ0M(1,4D00*ENE**2))**2
C    $        +CDABS(CPRAM (1,4D00*ENE**2))**2
        IF (IFINI) FACINI=1
        XM1=XM1/FACINI
        XM2=XM2/FACINI
        XM3=XM3/FACFIN
        XM4=XM4/FACFIN
        IF (IFINI) XM1=-(ph(1)**2+ph(2)**2)*(2-ph(3)/abs(ph(3)))
        IF (IFINI) XM2=-(ph(1)**2+ph(2)**2)*(2+ph(3)/abs(ph(3)))
        IF (BETTER) THEN
          IF (IFINI) THEN 
           XM=MIN(-XM1,-XM2,-XM1,-XM2)
          ELSE
           XM=MIN( XM4, XM3, XM3, XM4)
          ENDIF
        ELSE
           XM=MIN(-XM1,-XM2, XM3, XM4)
        ENDIF
        if (xm.lt.xmmax) then
!       ==
        DO 11 K=1,4
        IF     (XM1.EQ.-XM) THEN
          PP1(K)=PP1(K)-PH(K)
        ELSEIF (XM2.EQ.-XM) THEN
          PM1(K)=PM1(K)-PH(K)
        ELSEIF (XM3.EQ. XM) THEN
          QP1(K)=QP1(K)+PH(K)
        ELSEIF (XM4.EQ. XM) THEN
          QM1(K)=QM1(K)+PH(K)
        ELSE
          PRINT *,
     &    'SOMETHING IS STRANGE IN COMPILER MODIFY LOGIC OF SANGLE'
        ENDIF
 11     CONTINUE
        else
         do k=1,4
          phtru(k)=ph(k)
         enddo
        endif
 78     CONTINUE
      phtru(4)=sqrt(abs(phtru(1)**2+phtru(2)**2+phtru(3)**2))
c  boost to effective lab
      do k=1,4
       PS(k)= qp1(k)+qm1(k)+phtru(k)
      enddo

       call bostdq( 1,ps,pp1,pp1)
       call bostdq( 1,ps,pm1,pm1)
       call bostdq( 1,ps,phtru,phtru)
       call bostdq( 1,ps,qp1,qp1)
       call bostdq( 1,ps,qm1,qm1)
       call bostdq( 1,ps,ps,ps)
c lets correct masses of beams ...
       ebstar=ps(4)/2
       pbstar=sqrt(ebstar**2-amin**2)
       pp1s=sqrt(pp1(1)**2+pp1(2)**2+pp1(3)**2)
       pm1s=sqrt(pm1(1)**2+pm1(2)**2+pm1(3)**2)
       do k=1,3
        pp1(k)=pp1(k)*pbstar/pp1s
        pm1(k)=pm1(k)*pbstar/pm1s
       enddo
        pp1(4)=ps(4)/2
        pm1(4)=ps(4)/2
      do k=1,4
       PS(k)= qp1(k)+qm1(k)
      enddo
       call bostdq( 1,ps,qp1,qp1)
       call bostdq( 1,ps,qm1,qm1)
c lets correct masses of taus ...
       ebstar=(qp1(4)+qm1(4))/2
       pbstar=sqrt(ebstar**2-AMFIN**2)
       qp1s=sqrt(qp1(1)**2+qp1(2)**2+qp1(3)**2)
       qm1s=sqrt(qm1(1)**2+qm1(2)**2+qm1(3)**2)
       do k=1,3
        qp1(k)=qp1(k)*pbstar/qp1s
        qm1(k)=qm1(k)*pbstar/qm1s
       enddo
        qp1(4)=ebstar
        qm1(4)=ebstar

       call bostdq(-1,ps,qp1,qp1)
       call bostdq(-1,ps,qm1,qm1)

         aa=0d0
         do k=1,4
           test(k)=pp1(k)+pm1(k)-phtru(k)-qp1(k)-qm1(k)
           aa=aa+abs(test(k))
         enddo
       if (nphot.lt.-2) then
       write(*,*) '======  ',nphot
       do k=1,nphot
        write(*,*) SPHOT(K,4),SPHOT(K,3),SPHOT(K,2),SPHOT(K,1)
       enddo
       write(*,*) '----------------------------'
       write(*,*) ps(4),ps(3),ps(2),ps(1)
       write(*,*) pp1(4),pp1(3),pp1(2),pp1(1)
       write(*,*) pm1(4),pm1(3),pm1(2),pm1(1)
       write(*,*) '----------------------------'
       write(*,*) qp1(4),qp1(3),qp1(2),qp1(1)
       write(*,*) qm1(4),qm1(3),qm1(2),qm1(1)
       write(*,*) phtru(4),phtru(3),phtru(2),phtru(1)
       write(*,*) '----------------------------'
       write(*,*) test(4),test(3),test(2),test(1)
       write(*,*) '>>>>>>>>>>>>>>>>>>>>>>'
       sign=-1
        xmp=0
        xmm=0
        xqp=0
        xqm=0
        xphtr=0
        do k=1,4
         if (k.eq.4) sign=1
         xmp=xmp+sign*pp1(k)**2
         xmm=xmm+sign*pm1(k)**2
         xqp=xqp+sign*qp1(k)**2
         xqm=xqm+sign*qm1(k)**2
         xph=xph+sign*phtru(k)**2
        enddo
       write(*,*) xmp,xmm,xqp,xqm,xph
       endif

      if (ifkalin.eq.1) then
!     ##########################
        WTANOM=FKALIN(1,qp1,qm1,PHTRU)/FKALIN(0,qp1,qm1,PHTRU)
      elseif (ifkalin.eq.2) then
!     ##########################
        
***        print *,''
***        print *,'pp1 ',pp1
***        print *,'pm1 ',pm1
***        print *,'qp1 ',qp1
***        print *,'qm1 ',qm1
***        print *,'phtru ',phtru

        CALL FU_L3(IDE,IDF,pp1,pm1,qp1,qm1,phtru)

        WTANOM=1.0D0
        if (wtl3.gt.2.d0) then
          print *,''
          print *,'----> BIG WEIGHT!!! ',wtanom
        endif
      else
!     ####
        write(*,*) 'stop in wtanom, wrong IFKALIN=',IFKALIN
        stop
      endif
!     #####
      END
      function photmore(svar)
      IMPLICIT REAL*8 (A-H,O-Z)
C
      common /anomopti/ EMINACT,EMAXACT,PTACT,IRECSOFT,IENRICH
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      photmore=1d0
      if (ienrich.ne.1) return
      amz=91.177
      gamz=2.5
      u=(sqrt(svar)-amz)/gamz
      fac=1+amz/gamz/(1+u**2)**2
      ff=1/fac

      am1=53
      gam1=15
      u=(sqrt(svar)-am1)/gam1
      if (u.lt.0d0) u=u/2
      w1=6
      fac1=1+w1/(1+u**2)**2

      am2=110
      gam2=15
      u=(sqrt(svar)-am2)/gam2
      w2=2
      fac2=1+w2/(1+u**2)**2

      x=svar/4/ene**2
      photmore1=min(30d0,abs(1d0/x))

      photmore1=photmore1*fac1*fac2
      photmore2=min(30d0,abs(1d0/x**2))
      photmore=1d0+ff*(photmore1-1)

      end
 


      SUBROUTINE bostdq(mode,qq,pp,r)
*     *******************************
* Boost along arbitrary axis (as implemented by Ronald Kleiss).
* The method is described in book of Bjorken and Drell
* p boosted into r  from actual frame to rest frame of q
* forth (mode = 1) or back (mode = -1).
* q must be a timelike, p may be arbitrary.
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      DIMENSION qq(*),pp(*),r(*)
      DIMENSION q(4),p(4)

      DO k=1,4
         p(k)=pp(k)
         q(k)=qq(k)
      ENDDO
      amq =dsqrt(q(4)**2-q(1)**2-q(2)**2-q(3)**2)
      IF    (mode .EQ. -1) THEN
         r(4) = (p(1)*q(1)+p(2)*q(2)+p(3)*q(3)+p(4)*q(4))/amq
         fac  = (r(4)+p(4))/(q(4)+amq)
      ELSEIF(mode .EQ.  1) THEN
         r(4) =(-p(1)*q(1)-p(2)*q(2)-p(3)*q(3)+p(4)*q(4))/amq
         fac  =-(r(4)+p(4))/(q(4)+amq)
      ELSE
         WRITE(*,*) ' ++++++++ wrong mode in boost3 '
         STOP
      ENDIF
      r(1)=p(1)+fac*q(1)
      r(2)=p(2)+fac*q(2)
      r(3)=p(3)+fac*q(3)
      END

      SUBROUTINE MULSK(X,Y,R)
C ----------------------------------------------------------------------
C USED IN PEDYPR
C IT CALCULATES SCALAR PRODUCT OF FOUR VECTORS
C
C     called by : PEDYVV,PEDYPR,SANGLE,BDRESS,SKONTY
C ----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(4),Y(4)
      R=X(4)*Y(4)-X(3)*Y(3)-X(2)*Y(2)-X(1)*Y(1)
      END


      FUNCTION CPRZ0M(MODE,S)
C ----------------------------------------------------------------------
C THIS FUNCTION SUPPLIES TO THE PROGRAM Z0 PROPAGATOR
C IT USES Z0 VACUUM POLARIZATION MEMORIZED IN THE FUNCTION CINTZZ.
C INPUT : S (GEV**2)   PHOTON ENERGY TRANSFER.
C         MODE -INTERNAL KEY IN THE ALGORITHM,
C
C     called by : FUNTIH, FUNTIS, FANTIH,FANTIS, BORNS, SANGLE, BDRESS,
C                 SKONTY, AMPGSW
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
C     SWSQ        = sin2 (theta Weinberg)
C     AMW,AMZ     = W & Z boson masses respectively
C     AMH         = the Higgs mass
C     AMTOP       = the top mass
C     GAMMZ       = Z0 width
!      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMPLEX*16 CPRZ0,SIGMA,CPRZ0M
C
      CALL BornV_GetMZ(    AMZ)
      CALL BornV_GetGammZ( GammZ)

          SIGMA=DCMPLX(0D0,S/AMZ*GAMMZ)
          CPRZ0=DCMPLX((S-AMZ**2),0D0)
          CPRZ0M=1/(CPRZ0+SIGMA)
!      IF (KEYGSW.EQ.0) THEN
!        CPRZ0M=DCMPLX(0.D0,0.D0)
!        write(*,*) 'pajacyk'
!        stop
!      ENDIF

      END

      SUBROUTINE  anomini_l3
       write(*,*) 'WARNING: dummy routine anomini_l3 called'
       write(*,*) '         to calculate anomalous tau-tau-gamma couplings'
       write(*,*) '         it must be removed from anomface.f and ttglib from KORALZ loaded'
      END

      SUBROUTINE  kz_storeparms(ene,swsq,alfinv,amz,gammz,amfin,isfl,if2,if3)
      IMPLICIT REAL*8(A-H,O-Z)
       write(*,*) 'WARNING: dummy routine anomini_l3 called'
       write(*,*) '         to calculate anomalous tau-tau-gamma couplings'
       write(*,*) '         it must be removed from anomface.f and ttglib from KORALZ loaded'
      END

      SUBROUTINE  FU_L3(IDE,IDF,pp1,pm1,qp1,qm1,phtru)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 PP1(4),PM1(4),QP1(4),QM1(4),phtru(4)
       write(*,*) 'WARNING: dummy routine anomini_l3 called'
       write(*,*) '         to calculate anomalous tau-tau-gamma couplings'
       write(*,*) '         it must be removed from anomface.f and ttglib from KORALZ loaded'
      END

