      subroutine anomini(sw2i,mzi,gzi,mwi,gwi)
      IMPLICIT NONE
      real tabl
      COMMON /NEWMOD/  AMNEUT,NNEUT
      REAL*8           AMNEUT

      COMMON / gengto / TABL(40)
      real ephmin,ephmax,xtfmin,xtfmax,costhm
C*CA PHCUTS
      COMMON / PHCUTS / EPHMIN,EPHMAX,XTFMIN,XTFMAX,COSTHM
      double precision mz,gz,mw,gw,sw2,mzi,gzi,mwi,gwi,sw2i
      integer k,NNEUT
!! nwwg    = 1
!  nnwg ok inside, see also routine initialize for more input to
! geng.
       tabl(12)=  nneut
       mz=mzi
       gz=gzi
       mw=mwi
       gw=gwi
       sw2=sw2i
! old internal default. Reasonable for tests
!       mz=91.18d0 
!       gz=2.484
!       mw=80.046485
!       gw=2.2
!       sw2=.2293
       tabl(13)=mz  ! Z mass  for geng
       tabl(14)=gz  ! Z width for geng
       tabl(15)=mw
       tabl(16)=gw
       tabl(17)=sw2
!! k       = 10.d0
!! l       = 10.d0
!! kmax    = 10.d0
!! lmax    = 10.d0



C Default values for photon cuts irrelevant for KORALZ
C important for geng run standalone.
!! N_EV    = 4000
!! LUM     = 22.d0
!! nb1     = 1
!! nb2     = 1
!! MVV     = 0.0d0
!! angle   = 0.317d0
       COSTHM=0.317d0
!! Ephot   = 17.0d0
       EPHMIN= 17.0D0 
!! ENERGY  = 172.D0 
       tabl(16)=172./2.  !ecm/2

      EPHMIN=1.
      EPHMAX=1000.
      XTFMIN=0.
      XTFMAX=1.
      COSTHM=1.

      call gen_g
      end

      FUNCTION FKALIN(mode,QF1,QF2,PH)
      implicit real*8 (a-h,o-z)
      common /kalinout/ wtkal(6)
      common /kalinint/ sig(6)
      real*8 sig1(6)
      REAL*8 QF1(4),QF2(4)
      REAL*8 PH(4)
      common /flags/ nwwg,nneutr
      nnwgstor=nwwg
      nwwg=0

      a=FKALINA(mode,QF1,QF2,PH)
        xn1=sig(1)
      b=FKALINA(mode,QF2,QF1,PH)
        xn2=sig(1)

      nwwg=nnwgstor
      a=FKALINA(mode,QF1,QF2,PH)
      do i=1,6
        sig1(i)=sig(i)
      enddo
      b=FKALINA(mode,QF2,QF1,PH)

      svar=(qf1(4)+qf2(4))**2-(qf1(3)+qf2(3))**2
     $    -(qf1(2)+qf2(2))**2-(qf1(1)+qf2(1))**2
      if (mode.eq.1) then
       do i=1,6
         wtkal(i)=(sig(i)+sig1(i))/(xn1+xn2)
         wtkal(i)=wtkal(i)/photmore(svar)
       enddo
      endif
      fkalin=1d0

      end
      FUNCTION FKALINA(mode,QF1,QF2,PH)
      implicit real*8 (a-h,o-z)
      common /kalino/ ifkalin
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      real*8 delkappa(6),lambda(6)
      real*8 ydelkappa(6),ylambda(6)
      common/anom/delkappa,lambda
      common /kalinint/ wtkal(6)
!      common /kalinint/ sig(6)
      real*8 qq(4)
      REAL*8 QF1(4),QF2(4)
      REAL*8 PH(4),PB1(4),PB2(4),PHN(4)
      real*8 sig(6),Q(4,7)
      FKALINA=1D0
      if (ifkalin.eq.0) return
       do k=1,4
        rotek=1d0
!        if (k.eq.1) rotek= 1d0
        if (k.eq.2) rotek= 1d0
        if (k.eq.3) rotek= 1d0
        q(k,1)=0d0                  !e+
        q(k,2)=0d0                  !e-
        if (ide.lt.0) then
         q(k,3)=qf2(k)*rotek               ! nu     !*rotek
         q(k,4)=qf1(k)*rotek               ! nu~    !*rotek
        else
         q(k,3)=qf1(k)*rotek               ! nu     !*rotek
         q(k,4)=qf2(k)*rotek               ! nu~    !*rotek
        endif
        q(k,5)=ph(k)*rotek                ! gamma  !*rotek
        qq(k)=qf1(k)+qf2(k)+ph(k)
       enddo
        E=sqrt(qq(4)**2-qq(3)**2-qq(2)**2-qq(1)**2)/2
        p=sqrt(E**2-amin**2)
        q(4,1)= E
        q(4,2)= E
        if (ide.lt.0) then
         q(3,1)=-P
         q(3,2)= P
        else
         q(3,1)= P
         q(3,2)=-P
        endif
!!
      if (mode.ne.0) then
      ecm=2*e
      ncut=0
! next line may need commenting out
!      CALL CHECK_CUTS(ecm,Q,NCUT)

      call XSECTION(SIG,Q)

      fkalinup=0d0
      do i=1,6
        fkalinup=fkalinup+sig(i)
        fcut=1d0
        if (ncut.eq.1) fcut=0d0
        wtkal(i)=sig(i)  
      enddo 
         fkalina=1d0
      else

      fkalind=1d0
      fkalina=fkalind

      endif
      END












